/*
 * Potrebno je u toku dana u jednu salu smestiti sto vise aktivnosti. Kako se neke aktivnosti mozda preklapaju, potrebno je pronaci najveci broj aktivnosti koje se mogu odrzati
 * u zadatoj sali. Algoritam pohlepnim pristupom odabira aktivnosti birajuci prvenstveno one koje se prve zavrsavaju.
 */

#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>
#include <string>

using namespace std;

bool poredi(pair<string,string> t1, pair<string,string> t2)
{
    return t1.second < t2.second;
}

int main()
{
    vector<pair<string, string> > termini;
    
    int n;
    cin >> n;
    
    string pocetak;
    string kraj;
    
    for(int i = 0; i < n; i++)
    {
        cin >> pocetak >> kraj;
        termini.push_back(make_pair(pocetak, kraj));
    }
    
    make_heap(termini.begin(), termini.end(), poredi);
    sort_heap(termini.begin(), termini.end(), poredi);
    
    cout << endl;
    
    pair<string,string> trenutna = termini[0];
    
    cout << trenutna.first << " - " << trenutna.second << endl;
    
    for(int i = 1; i < n; i++)
    {
        if(termini[i].first > trenutna.second)
        {
            trenutna = termini[i];
            cout << trenutna.first << " - " << trenutna.second << endl;
        }
    }
    
    return 0;
}