/*
 * Algoritam primenom grube sile pronalazi duzinu najkraceg puta u grafu izmedju dva cvora, modifikacijom DFS algoritma, proveravajuci sve moguce puteve.
 */

#include <iostream>
#include <vector>
#include <list>
#include <cstdlib>

using namespace std;

struct Graf
{
    vector<list<int> > lista;
    vector<bool> oznaceni;
    
    void ucitaj_graf(int n)
    {
        if(n <= 0)
        {
            cerr << "Neispravna dimenzija!";
            exit(EXIT_FAILURE);
        }
        
        
        
        inicijalizacija(n);
        
        for(int i = 0; i < n; i++)
        {
            
            oznaceni[i] = false;
            
            int m;
            cout << "Broj suseda cvora " << i << ": ";
            cin >> m;
            cout << "Susedi cvora " << i << ": ";
            for(int j = 0; j < m; j++)
            {
                int sused;
                cin >> sused;
                
                if(sused < 0 || sused >= n)
                {
                    cerr << "Neispravna grana!";
                    exit(EXIT_FAILURE);
                }
                
                lista[i].push_back(sused); 
            }  
            cout << endl;
                
        }
  
        
    }
    
    void DFS(int cvor, int trazeni, int duzina, int &min_duzina)
    {

         if(cvor < 0 || cvor >= oznaceni.size())
         {
             cerr << "Neispravan pocetni cvor!";
             exit(EXIT_FAILURE);
         }
         
         if(cvor == trazeni)
         {
             if(duzina < min_duzina)
                min_duzina = duzina;
             
             return;
         }
    
        oznaci(cvor);
        
        // Za sve neoznacene susede poziva se rekurzivno DFS obilazak
        for(auto it = lista[cvor].begin(); it != lista[cvor].end(); it++)
            if(neoznacen(*it))
                DFS(*it, trazeni, duzina + 1, min_duzina);
            
        oznaceni[cvor] = false;
    }
    
    // Inicijalizacija grafa; ciscenje liste i vektora sa oznakama i postavljanje novih velicina
    void inicijalizacija(int n)
    {
        for(int i = 0; i < lista.size(); i++)
            lista[i].clear();
        
        lista.clear();        
        oznaceni.clear();
        
        lista.resize(n);
        oznaceni.resize(n);
    }
    
    void oznaci(int cvor)
    {
        oznaceni[cvor] = true;
    }
    
    bool neoznacen(int cvor)
    {
        return !oznaceni[cvor];
    }
    
};

int main()
{
    Graf g;
    
    int n;
    
    cin >> n;
    
    g.ucitaj_graf(n);
    
    int max_duzina = 99999;
    
    g.DFS(0, 4, 0, max_duzina);
    
    cout << max_duzina << endl;
    

    return 0;
}